"""
Django settings for SkilesGroup project.

Generated by 'django-admin startproject' using Django 3.2.9.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""
import os
from pathlib import Path
import datetime
# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-6y-7s4)mquwcc&)o75j35pr6g@*4ue6*x%49x!cy9w6^aw)@y0'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*']

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.sites',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'storages',
    'skilesgroup_app',
    'rest_framework',
    'rest_framework_swagger',
    'django_crontab',
    'drf_yasg',
    'django.contrib.flatpages',
    'anymail',
]
SITE_ID = 1

CORS_ORIGIN_ALLOW_ALL = True

MIDDLEWARE = [
    'django.contrib.flatpages.middleware.FlatpageFallbackMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'corsheaders.middleware.CorsMiddleware',
]

ROOT_URLCONF = 'SkilesGroup.urls'
DEFAULT_AUTHENTICATION_CLASSES = [
    'rest_framework.authentication.SessionAuthentication',
    'rest_framework.authentication.BasicAuthentication'
]
TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'SkilesGroup.wsgi.application'
# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases
# Local Database
# DATABASES = {
#     'default': {
#         'NAME': 'insightdaddy_active_skilesgroup',
#         'ENGINE': 'django.db.backends.mysql',
#         'USER': 'insightdaddy_skilesadmin',
#         'PORT': '3306',
#         'HOST': '127.0.0.1',
#         'PASSWORD': 'i8ktexcpqsks',
#         'OPTIONS': {
#          'charset': 'utf8mb4'
#         }
#     }
# }
#  RDS DATABASE
DATABASES = {
    'default': {
        'NAME': 'skilesdbnew',
        'ENGINE': 'django.db.backends.mysql',
        'USER': 'admin',
        'PORT': '3306',
        'HOST': 'skilesgroupdbcluster.co09qlxzqeva.us-east-1.rds.amazonaws.com',
        'PASSWORD': 'ymON6yoJRFmGt3Trljyj',
        'OPTIONS': {
         'charset': 'utf8mb4'
        }
    }
}

# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'
REST_FRAMEWORK = {
    # Use Django's standard `django.contrib.auth` permissions,
    # or allow read-only access for unauthenticated users.
    "DEFAULT_PERMISSION_CLASSES": [
        "rest_framework.permissions.IsAdminUser",
        # 'rest_framework.permissions.IsAuthenticated',
    ]
    # 'DEFAULT_AUTHENTICATION_CLASSES': [
        # 'rest_framework.authentication.BasicAuthentication',
        # 'rest_framework.authentication.SessionAuthentication',
        # 'rest_framework.authentication.TokenAuthentication',
    # ]
}

SWAGGER_SETTINGS = {
    'DEFAULT_INFO': 'news.urls.openapi_info',
      'SECURITY_DEFINITIONS': {
        'basic': {
            'type': 'basic',
            'LOGIN_URL': 'rest_framework:login',
            'LOGOUT_URL': 'rest_framework:logout',
            'USE_SESSION_AUTH': True,
            'DOC_EXPANSION': 'list',
            'APIS_SORTER': 'alpha',
            'SECURITY_DEFINITIONS': None,

        }
    },

}

ANYMAIL = {
    # (exact settings here depend on your ESP...)
    "MAILGUN_API_KEY": "bbfc0390158526de6e023818fce0f66b-135a8d32-729bca99",
}
EMAIL_BACKEND = "anymail.backends.mailgun.EmailBackend"  # or sendgrid.EmailBackend, or...
DEFAULT_FROM_EMAIL = "no-reply@hsmcontech.com"  # if you don't already have this in settings
SERVER_EMAIL = "skiles@hsmcontech.com"
EMAIL_HOST_USER = 'no-reply@hsmcontech.com'
EMAIL_USE_TLS = True

CRONJOBS = [
    ('40 12 * * *', 'skilesgroup_app.skilescron.formspdf', '>> ' + os.path.join(BASE_DIR,'logs/formpdflog.log' + ' 2>&1 ')),
    # ('30 07 * * *', 'skilesgroup_app.skilescron.formspdf', '>> ' + os.path.join(BASE_DIR,'logs/formpdflog.log' + ' 2>&1 ')),
    # ('15 06 * * *', 'skilesgroup_app.skilescron.createcron', '>> ' + os.path.join(BASE_DIR, f'logs/cronjob.log' + ' 2>&1 ')),
    # ('30 2 * * *', 'skilesgroup_app.skilescron.create_busybusy', '>> ' + os.path.join(BASE_DIR,'logs/cronjob.log' + ' 2>&1 ')),
    # ('15 1 * * *', 'skilesgroup_app.skilescron.get_ticket', '>> ' + os.path.join(BASE_DIR,'logs/cronjob.log' + ' 2>&1 ')),
    #  ('15 13 * * *', 'skilesgroup_app.cron.createcron', '>> ' + os.path.join(BASE_DIR,'logs/cronjob.log' + ' 2>&1 ')),
     
]                  
# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field
REST_FRAMEWORK = {

    'DEFAULT_SCHEMA_CLASS': 'rest_framework.schemas.coreapi.AutoSchema'

                   }

SWAGGER_SETTINGS = {
    'USE_SESSION_AUTH': False,
}
LOGIN_URL = '/api/login'
# LOGIN_REDIRECT_URL = 'swagger'
DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
# AWS_ACCESS_KEY_ID = 'AKIA24FXZDZFY7BK3E4N'
# AWS_SECRET_ACCESS_KEY = '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'
# AWS_STORAGE_BUCKET_NAME = 'hsm-regular-db-backup'
# AWS_S3_CUSTOM_DOMAIN = '%s.s3.amazonaws.com' % AWS_STORAGE_BUCKET_NAME
# AWS_S3_OBJECT_PARAMETERS = {
#     'CacheControl': 'max-age=86400',
# }
# AWS_LOCATION = 'static'

# STATIC_URL = 'https://%s/%s/' % (AWS_S3_CUSTOM_DOMAIN, AWS_LOCATION)
# STATICFILES_STORAGE = 'storages.backends.s3boto3.S3Boto3Storage'
STATIC_URL = '/static/'
STATIC_ROOT = "static/"
MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media/') 