
from django.db import models
# Create your models here.
# class user(models.Model):
#     name = models.CharField(max_length=200,null = False,blank = False)
#     email = models.EmailField(max_length=100,null = False,blank = False)
#     password = models.CharField(max_length=100,null = False,blank = False)
#     address_line1 = models.CharField(max_length=100,default=None,blank=True,null=True)
#     address_line2 = models.CharField(max_length=100,default=None,blank=True,null=True)
#     telephone = models.CharField(max_length=100,default=None,blank=True,null=True)
#     zip_code = models.CharField(max_length=20,default=None,blank=True,null=True)
#     state = models.CharField(max_length=100,default=None,blank=True,null=True)
#     country = models.CharField(max_length=100,default=None,blank=True,null=True)
#
#     def __str__(self):
#         return self.name
from datetime import date



class ProjectModel(models.Model):
    project_id = models.IntegerField()
    project_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    status_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    def __str__(self):
        return f"{self.project_id}"
    class Meta:
        db_table = "project_model"

class CommitmentsChangeOrder(models.Model):
    commitments_contract_id  = models.IntegerField()
    date_initiated = models.TextField(default=None,blank=True,null=True)
    due_date =models.TextField(default=None,blank=True,null=True)
    executed =models.TextField(default=None,blank=True,null=True)
    grand_total =models.TextField(default=None,blank=True,null=True)
    number =models.TextField(default=None,blank=True,null=True)
    reviewed_at= models.TextField(default=None,blank=True,null=True)
    signed_change_order_received_date= models.TextField(default=None,blank=True,null=True)
    status =models.TextField(default=None,blank=True,null=True)
    title =models.TextField(default=None,blank=True,null=True)
    updated_at =models.TextField(default=None,blank=True,null=True)
    revision =models.TextField(default=None,blank=True,null=True)
    designated_reviewer_login= models.TextField(default=None,blank=True,null=True)
    designated_reviewer_name =models.TextField(default=None,blank=True,null=True)



class SyncTables(models.Model):
    company_id = models.IntegerField()
    access_token = models.TextField(default=None,blank=True,null=True)
    refresh_token = models.CharField(max_length=255, blank=True, null=True)
    created_at =models.DateTimeField(auto_now=True)
    updated_at = models.DateTimeField(auto_now=True)
    class Meta:
        db_table = 'sync_tables'









class Submittals(models.Model):
    project = models.ForeignKey(ProjectModel,on_delete=models.CASCADE)
    submittal_id = models.IntegerField()
    submittal_revision = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_distributed_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_received_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_issue_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_type = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_update_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_open_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    submittal_specification_section = models.TextField(default=None,blank=True,null=True)


    class Meta:
        db_table = "submittals"

class SubmittalsStatus(models.Model):
    submittal = models.ForeignKey(Submittals,related_name='status',on_delete=models.CASCADE)
    submittal_status_id =  models.IntegerField()
    submittal_status_name = models.CharField(max_length=20, default=None, blank=True, null=True)
    submittal_status_status = models.CharField(max_length=20,default=None,blank=True,null=True)
    class Meta:
        db_table = "submittals_status"

class SubmittalResponsibleContractor(models.Model):
    submittal = models.ForeignKey(Submittals,related_name='responsible_contractor',on_delete=models.CASCADE)
    rc_id = models.IntegerField()
    rc_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "submittals_responsible_contractor"

class SubmittalRecievedFrom(models.Model):
    submittal = models.ForeignKey(Submittals,related_name='recieved_from',on_delete=models.CASCADE)
    rf_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    rf_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "submittals_recieved_from"

class SubmittalBallInCourt(models.Model):
    submittal = models.ForeignKey(Submittals,related_name='ball_in_court',on_delete=models.CASCADE)
    bic_id =models.IntegerField()
    bic_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    bic_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "submittals_ball_in_court"

class SubmittalApprover(models.Model):
    submittal = models.ForeignKey(Submittals,related_name='approver', on_delete=models.CASCADE)
    approver_id =models.IntegerField()
    approver_return_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    approver_sent_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    approver_sent_response = models.CharField(max_length=250,default=None,blank=True,null=True)
    approver_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    approval_type = models.CharField(max_length=250, default=None, blank=True, null=True)
    class Meta:
        db_table = "submittals_approver"

class SubmittalApproverUser(models.Model):
    submittal_approver = models.ForeignKey(SubmittalApprover,related_name='approver_user', on_delete=models.CASCADE)
    sau_id = models.IntegerField()
    sau_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    sau_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "submittals_approver_user"



class ProjectUser(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pu_id  = models.IntegerField()
    pu_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    pu_email = models.CharField(max_length=250,default=None,blank=True,null=True)
    permission_template_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    job_title = models.CharField(max_length=250, default=None, blank=True, null=True)
class ProjectUserVendor(models.Model):
    project_user = models.ForeignKey(ProjectUser, related_name='vendor',on_delete=models.CASCADE)
    vendor_id =models.IntegerField()
    vendor_name = models.CharField(max_length=250,default=None,blank=True,null=True)

#
#
#
#
#
#
class Rfi(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    rfi_id = models.IntegerField()
    rfi_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_initiated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_time_resolved = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    rfi_subject = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi"

class RfiCustomFields1(models.Model):
    rfi = models.ForeignKey(Rfi, related_name="custom_field_239137", on_delete=models.CASCADE)
    value_id = models.IntegerField(default=None)
    value_label = models.CharField(max_length=250, default=None, blank=True, null=True)
    class Meta:
        db_table = "rfi_custom_fields_1"

class RfiCustomFields2(models.Model):
    rfi = models.ForeignKey(Rfi, related_name="custom_field_267744", on_delete=models.CASCADE)
    value_id = models.IntegerField(default=None)
    value_label = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_custom_fields_2"


class RfiAssignees(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="assignee",on_delete=models.CASCADE)
    ra_id = models.IntegerField()
    ra_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ra_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_assignees"
#
class RfiBallInCourt(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="ball_in_court",on_delete=models.CASCADE)
    rbic_id = models.IntegerField()
    rbic_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    rbic_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_ball_in_court"
#
class RfiCostImpact(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="cost_impact",on_delete=models.CASCADE)
    rci_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    rci_value = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_cost_impact"
#
class RfiRecievedFrom(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="recieved_from", on_delete=models.CASCADE)
    rcf_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    rcf_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_recieved_at"

class RfiScheduleImpact(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="schedule_impact", on_delete=models.CASCADE)
    rsi_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    rsi_value = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_schedule_impact"

class RfiLocation(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="location", on_delete=models.CASCADE)
    rl_id = models.IntegerField()
    rl_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_location"

class RfiResponsibleContractor(models.Model):
    rfi = models.ForeignKey(Rfi,related_name="responsible_contractor", on_delete=models.CASCADE)
    rrc_id = models.IntegerField()
    rrc_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "rfi_responsible_contractor"


class ProjectDetails(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pd_id =models.IntegerField()
    name= models.CharField(max_length=250,default=None,blank=True,null=True)
    display_name= models.CharField(max_length=250,default=None,blank=True,null=True)
    project_number= models.CharField(max_length=250,default=None,blank=True,null=True)
    address= models.CharField(max_length=250,default=None,blank=True,null=True)
    city= models.CharField(max_length=250,default=None,blank=True,null=True)
    created_at= models.CharField(max_length=250,default=None,blank=True,null=True)
    updated_at= models.CharField(max_length=250,default=None,blank=True,null=True)
    active= models.CharField(max_length=250,default=None,blank=True,null=True)
    estimated_value= models.CharField(max_length=250,default=None,blank=True,null=True)
    start_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    completion_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    total_value= models.CharField(max_length=250,default=None,blank=True,null=True)
    project_stage_name= models.CharField(max_length=250,default=None,blank=True,null=True)
    square_feet = models.CharField(max_length=250, default=None, blank=True, null=True)
    actual_start_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    projected_finish_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    estimated_start_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    estimated_completion_date = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "project_details"


class ProjectDetailsCustomFields(models.Model):
    detail = models.ForeignKey(ProjectDetails,related_name="custom_field",on_delete=models.CASCADE)
    custom_field_161571_value = models.CharField(max_length=250,default=None,blank=True,null=True)
    custom_field_161578_value = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "project_details_custom_field"
#
#
#
class ProjectDetailsPersistentMessage(models.Model):
    project_details = models.ForeignKey(ProjectDetails,related_name="persistant_message",on_delete=models.CASCADE)
    title = models.CharField(max_length=250,default=None,blank=True,null=True)
    message = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "project_details_persistent_message"
#
#
class ProjectDetailsOffice(models.Model):
    project_details = models.ForeignKey(ProjectDetails,related_name="office", on_delete=models.CASCADE)
    pdo_id = models.IntegerField()
    pdo_name =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_address =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_city =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_state_code =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_country_code =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_zip =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_phone =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_fax =  models.CharField(max_length=250,default=None,blank=True,null=True)
    pdo_division =  models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "project_details_office"


class ScheduleTask(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    schedule_id = models.IntegerField()
    schedule_name = models.TextField(default=None,blank=True,null=True)
    schedule_start_datetime = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_finish_datetime = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_percentage = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_resource_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_critical_path = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_milestone = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_actual_start = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_actual_finish = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_wps = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_schedule_duration = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_resource_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_baseline_start = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_baseline_finish = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_start_variance = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_finish_variance = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_task_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    schedule_has_children = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "schedule_task"
#
class WorkTask(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    work_id =models.IntegerField()
    work_parent_id  = models.CharField(max_length=250,default=None,blank=True,null=True)
    work_percentage  = models.CharField(max_length=250,default=None,blank=True,null=True)
    work_updated_at  = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "work_task"
#
class DailyHuddles(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    dh_id =  models.IntegerField()
    dh_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    dh_item_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    dh_responder = models.CharField(max_length=250,default=None,blank=True,null=True)
    dh_response = models.CharField(max_length=250,default=None,blank=True,null=True)
    dh_responded_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "daily_huddles"




class DailyLogManpower(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    dlm_id = models.IntegerField()
    dlm_create_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_custom_fields = models.TextField(default=None,blank=True,null=True)
    dlm_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_man_hour = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_num_worker = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_num_hour = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_update_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    dlm_status = models.CharField(max_length=250,default=None,blank=True,null=True)


    class Meta:
        db_table = "daily_log_manpower"

class DlmVendor(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="vendor", on_delete=models.CASCADE)
    dlmv_id = models.IntegerField()
    dlmn_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "daily_log_manpower_vendor"

class DlmCreatedBy(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="created_by", on_delete=models.CASCADE)
    dlmv_id = models.IntegerField()
    dlmn_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "daily_log_manpower_created_by"

# newly added
class DlmCustomField1(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="field1", on_delete=models.CASCADE)
    value_label = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "daily_log_manpower_custom_field_239131"

# newly added
class DlmCustomField2(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="field2", on_delete=models.CASCADE)
    value_label = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "daily_log_manpower_custom_field_239132"

# newly added
class DlmCustomField3(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="field3", on_delete=models.CASCADE)
    value_label = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "daily_log_manpower_custom_field_239133"

# newly added
class DlmCustomField4(models.Model):
    dlm = models.ForeignKey(DailyLogManpower,related_name="field4", on_delete=models.CASCADE)
    value_label = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "daily_log_manpower_custom_field_243785"




class WeeklyWipedown(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    ww_id = models.IntegerField()
    ww_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ww_item_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ww_responder = models.CharField(max_length=250,default=None,blank=True,null=True)
    ww_response = models.CharField(max_length=250,default=None,blank=True,null=True)
    ww_responded_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "weekly_wipedown"
#
#
class PercentPlanComplete(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    ppc_id = models.IntegerField()
    ppc_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ppc_item_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ppc_responder = models.CharField(max_length=250,default=None,blank=True,null=True)
    ppc_response_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    ppc_responded_with=models.CharField(max_length=250,default=None,blank=True,null=True)
    
    class Meta:
        db_table = "percent_plan_complete"

class Invoicing (models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    i_id = models.IntegerField()
    invoicing_billing_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_percent_complete= models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_status= models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_total_amount_paid= models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_total_amount_accrued_this_period= models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_contract= models.CharField(max_length=250,default=None,blank=True,null=True)
    invoicing_formatted_contract_company= models.CharField(max_length=250,default=None,blank=True,null=True)
    total_completed_and_stored_to_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    total_earned_less_retainage = models.CharField(max_length=250,default=None,blank=True,null=True)
    total_retainage = models.CharField(max_length=250,default=None,blank=True,null=True)
    balance_to_finish_including_retainage = models.CharField(max_length=250,default=None,blank=True,null=True)
    completed_work_retainage_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    completed_work_retainage_percent = models.CharField(max_length=250,default=None,blank=True,null=True)
    contract_sum_to_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    formatted_period = models.CharField(max_length=250,default=None,blank=True,null=True)
    original_contract_sum = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "invoicing"

#
class PrimeContractGeneralview(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pcgv_id = models.IntegerField()
    number = models.CharField(max_length=250,default=None,blank=True,null=True)
    company = models.CharField(max_length=250,default=None,blank=True,null=True)
    architect = models.CharField(max_length=250,default=None,blank=True,null=True)
    retainage_percent = models.CharField(max_length=250,default=None,blank=True,null=True)
    approval_letter_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    approved_change_orders = models.CharField(max_length=250,default=None,blank=True,null=True)
    executed = models.CharField(max_length=250,default=None,blank=True,null=True)
    status = models.CharField(max_length=250,default=None,blank=True,null=True)
    date_created = models.CharField(max_length=250,default=None,blank=True,null=True)
    estimated_completion_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    signed_contract_received_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    contract_start_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    actual_completion_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    contract_termination_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    grand_total = models.CharField(max_length=250,default=None,blank=True,null=True)
    outstanding_balance = models.CharField(max_length=250,default=None,blank=True,null=True)
    pending_change_orders_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    pending_revised_contract_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    draft_change_orders_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    owner_invoices_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    payments_received = models.TextField(default=None,blank=True,null=True)
    percentage_paid = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "prime_contract_general_view"
# #
# #
# #
# #
# #
class PrimeContractScheduleValue(models.Model):

    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pcsv_id = models.IntegerField()
    pcsv_budget_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcsv_actual_description = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcsv_allow_extended_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "prime_contract_schedule_value"



class PrimeContractChangeOrder(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pcco_id = models.IntegerField()
    pcco_contract_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_created_by_id = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_due_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_executed = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_grand_total = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_reviewed_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_status = models.CharField(max_length=250, default=None, blank=True, null=True)
    pcco_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_revision = models.CharField(max_length=250,default=None,blank=True,null=True)
    pcco_designated_reviewer = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "prime_contract_change_order"


#
#
class Inspection(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    inspection_id = models.IntegerField()
    inspection_list_template_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    inspected_item_count = models.CharField(max_length=250,default=None,blank=True,null=True)
    item_count= models.CharField(max_length=250,default=None,blank=True,null=True)
    inspection_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    inspection_closed_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    inspection_assignee = models.CharField(max_length=250,default=None,blank=True,null=True)
    neutral_item_count = models.CharField(max_length=250,default=None,blank=True,null=True)
    responsible_contractor = models.CharField(max_length=250,default=None,blank=True,null=True)
    conforming_item_count = models.CharField(max_length=250,default=None,blank=True,null=True)
    deficient_item_count = models.CharField(max_length=250,default=None,blank=True,null=True)
    not_applicable_item_count =models.CharField(max_length=250,default=None,blank=True,null=True)
    inspection_type = models.CharField(max_length=30,default=None,blank=True,null=True)
    inspection_status = models.CharField(max_length=30,default=None,blank=True,null=True)
    class Meta:
        db_table = "inspection"




class Incident(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    incident_id = models.IntegerField()
    incident_created_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_deleted_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_description = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_event_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_number = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_private = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_recordable = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_records_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_status = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_time_unknown = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_title = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_open_observations_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_closed_observations_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_attachments_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_witness_statements_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    incident_actions_count = models.CharField(max_length=250, default=None, blank=True, null=True)
    #incident_contributing_condition = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "incident"

class IncidentCreatedBy(models.Model):
    incident = models.ForeignKey(Incident,related_name="incident_created", on_delete=models.CASCADE)
    icb_id = models.IntegerField()
    icb_login =models.CharField(max_length=250,default=None,blank=True,null=True)
    icb_name =models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "incident_created_by"
class IncidentLocation(models.Model):
    incident = models.ForeignKey(Incident,related_name="incident_location", on_delete=models.CASCADE)
    il_id = models.IntegerField()
    il_updated_at =models.CharField(max_length=250,default=None,blank=True,null=True)
    il_parent_id =models.CharField(max_length=250,default=None,blank=True,null=True)
    il_node_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    il_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    il_created_at = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "incident_location"

class IncidentContributingBehavior(models.Model):
    incident = models.ForeignKey(Incident,related_name="contributing_behavior", on_delete=models.CASCADE)
    icb_id = models.IntegerField()
    icb_active =models.CharField(max_length=250,default=None,blank=True,null=True)
    icb_created_at =models.CharField(max_length=250,default=None,blank=True,null=True)
    icb_global = models.CharField(max_length=250, default=None, blank=True, null=True)
    icb_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    icb_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "incident_contributing_behavior"

class IncidentContributingCondition (models.Model):
    incident = models.ForeignKey(Incident,related_name="contributing_condition", on_delete=models.CASCADE)
    icc_id = models.IntegerField()
    icc_active =models.CharField(max_length=250,default=None,blank=True,null=True)
    icc_created_at =models.CharField(max_length=250,default=None,blank=True,null=True)
    icc_global = models.CharField(max_length=250, default=None, blank=True, null=True)
    icc_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    icc_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "incident_contributing_condition"

class IncidentHazard(models.Model):
    incident = models.ForeignKey(Incident,related_name="incident_hazard", on_delete=models.CASCADE)
    ih_id = models.IntegerField()
    ih_updated_at =models.CharField(max_length=250,default=None,blank=True,null=True)
    ih_active =models.CharField(max_length=250,default=None,blank=True,null=True)
    ih_global = models.CharField(max_length=250, default=None, blank=True, null=True)
    ih_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    ih_created_at = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "incident_hazard"

class PunchList(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    punch_list_id = models.IntegerField()
    punch_list_status = models.CharField(max_length=20,default=None,blank=True,null=True)
    punch_list_priority = models.CharField(max_length=20,default=None,blank=True,null=True)
    class Meta:
        db_table = "punch_list"

class Budget(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    budget_id = models.IntegerField()
    budget_manual_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_automatic_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_automatically_calculated = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_budget_row_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_cost_code_level_1 = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_cost_code_level_2 = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_category_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_category = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_project_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_project = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_budget_modifications = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_original_budget_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_approved_cos = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_committed_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_erp_job_to_date_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_pending_budget_changes = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_pending_cost_changes = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_erp_direct_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_estimated_cost_at_completion = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_projected_budget = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_projected_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_projected_over_under = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_revised_budget = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_approved_ccos = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_revised_commitment_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_uncommitted_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_approved_cco = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_pending_committed = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_current_jc_budget = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_direct_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_job_to_date_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_change_events = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_commitments = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_erp_job_costs = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_payment_applications = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_prime = models.CharField(max_length=250,default=None,blank=True,null=True)
    budget_requisitions = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "budget"


class BudgetWpsCode(models.Model):
    budget = models.ForeignKey(Budget,related_name="wps_code", on_delete=models.CASCADE)
    bwc_id = models.IntegerField()
    bwc_description =models.CharField(max_length=250,default=None,blank=True,null=True)
    bwc_flat_code =models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "budget_wps_code"

class BudgetWpsSegment(models.Model):
    budget_wps = models.ForeignKey(BudgetWpsCode,related_name="wps_segment", on_delete=models.CASCADE)
    bws_id = models.IntegerField()
    bws_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    bws_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    bws_path_codes = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "budget_wps_segment_items"



class Commitment(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    commitment_id = models.IntegerField()
    commitment_actual_completion_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_approved_change_orders= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_billing_schedule_of_values_status= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_contract_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_contract_estimated_completion_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_contract_start_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_created_at= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_draft_change_orders_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_executed= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_execution_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_grand_total= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_issued_on_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_number= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_origin_code= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_pending_change_orders= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_pending_revised_contract= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_percentage_paid= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_remaining_balance_outstanding= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_retainage_percent= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_returned_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_revised_contract= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_signed_contract_received_date= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_status= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_title= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_total_draw_requests_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_total_payments= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_total_requisitions_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_updated_at= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "commitment"


class CommitmentVendor(models.Model):
    commitment =  models.ForeignKey(Commitment,related_name="vendor", on_delete=models.CASCADE)
    cv_id = models.IntegerField(null=True,default=None,blank=True)
    cv_company = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "commitment_vendor"


class CommitmentProject(models.Model):
    commitment =  models.ForeignKey(Commitment,related_name="commitment_project", on_delete=models.CASCADE)
    cp_id = models.IntegerField()
    cp_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "commitment_project"



class ChangeEvents(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    c_e_id = models.IntegerField()
    total_amount_of_rom = models.FloatField(default=None,blank=True,null=True)
    change_events_status = models.CharField(max_length=20,default=None,blank=True,null=True)
    created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    event_scope = models.CharField(max_length=250,default=None,blank=True,null=True)
    event_type = models.CharField(max_length=250,default=None,blank=True,null=True)
    number = models.CharField(max_length=250,default=None,blank=True,null=True)
    alphanumeric_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    title = models.CharField(max_length=250,default=None,blank=True,null=True)
    updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    # change_event_line_items = models.CharField(250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event"

class ChangeOrderChangeReason(models.Model):
    change_event = models.ForeignKey(ChangeEvents,related_name="change_reason",on_delete=models.CASCADE)
    #Company ID
    cocr_id = models.IntegerField()
    cocr_change_reason = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_order_change_reason"


class ChangeOrderChangeEventStatus(models.Model):
    change_event = models.ForeignKey(ChangeEvents,related_name="change_event_status", on_delete=models.CASCADE)
    coces_id = models.IntegerField()
    coces_name= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_order_change_event_status"

class ChangeEventLineItems(models.Model):

    change_event = models.ForeignKey(ChangeEvents,related_name="line_items", on_delete=models.CASCADE)
    celi_id = models.IntegerField()
    description= models.CharField(max_length=250,default=None,blank=True,null=True)
    estimated_cost_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    event_id= models.CharField(max_length=250,default=None,blank=True,null=True)
    rfq_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    rom= models.CharField(max_length=250,default=None,blank=True,null=True)
    sortable_code= models.CharField(max_length=250,default=None,blank=True,null=True)
    status= models.CharField(max_length=250,default=None,blank=True,null=True)
    statuses= models.CharField(max_length=250,default=None,blank=True,null=True)
    event_title_and_number= models.CharField(max_length=250,default=None,blank=True,null=True)
    latest_revenue_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    over_under_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    revenue_rom_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    non_committed_cost= models.CharField(max_length=250,default=None,blank=True,null=True)
    manual_latest_cost_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    latest_cost_amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    prime_pco_cost= models.CharField(max_length=250,default=None,blank=True,null=True)
    committed_cost= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_pco_cost= models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_contract_cost= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event_line_items"



class CeliVendor(models.Model):
    celi = models.ForeignKey(ChangeEventLineItems,related_name="celi_vendor",on_delete=models.CASCADE)
    celiv_id = models.IntegerField()
    celiv_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event_line_items_vendor"

class CeLineItemsBiller(models.Model):
    change_eventline_items = models.ForeignKey(ChangeEventLineItems,related_name="biller", on_delete=models.CASCADE)
    celi_id = models.IntegerField()
    name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event_line_item_biller"

class CeLineItemsContract(models.Model):
    celi = models.ForeignKey(ChangeEventLineItems,related_name="contract", on_delete=models.CASCADE)
    celic_id = models.IntegerField()
    celic_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    celic_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event_line_item_contract"
class CeLineItemsCostCode(models.Model):
    celic = models.ForeignKey(ChangeEventLineItems, related_name="cost_code",on_delete=models.CASCADE)
    celicc_id = models.IntegerField()
    celicc_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    celicc_full_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    celicc_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    celicc_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    cclicc_updated_at =  models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_event_line_items_cost_code"

class CelicLineItemTypes(models.Model):
    celicli = models.ForeignKey(CeLineItemsCostCode,related_name="type",on_delete=models.CASCADE)
    celiclit_id = models.IntegerField()
    celiclit_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    celiclit_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "celic_line_item_type"

class ChangeOrderPackagesView(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    Copv_id = models.IntegerField()
    Copv_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    Copv_executed = models.CharField(max_length=250,default=None,blank=True,null=True)
    Copv_invoiced_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    Copv_paid_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    Copv_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    Copv_change_reasons = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "change_order_package_view"
#
# #from bamboo HR
class Training(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    training_id = models.IntegerField()
    trainig_employee_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    training_completed= models.CharField(max_length=250,default=None,blank=True,null=True)
    trainig_notes= models.CharField(max_length=250,default=None,blank=True,null=True)
    trainig_type= models.CharField(max_length=250,default=None,blank=True,null=True)
    # trainig_traning_data= models.CharField(max_length=250,default=None,blank=True,null=True)
    trainig_employee_name= models.CharField(max_length=250,default=None,blank=True,null=True)
    trainig_employee_designation= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "training"

class TrainingData(models.Model):
    training = models.ForeignKey(Training,related_name="training_data",on_delete=models.CASCADE)
    td_id = models.IntegerField()
    td_name= models.CharField(max_length=250,default=None,blank=True,null=True)
    td_renewable= models.CharField(max_length=250,default=None,blank=True,null=True)
    td_frequency = models.CharField(max_length=250,default=None,blank=True,null=True)
    td_required= models.CharField(max_length=250,default=None,blank=True,null=True)
    td_category= models.CharField(max_length=250,default=None,blank=True,null=True)
    td_linkUrl= models.CharField(max_length=250,default=None,blank=True,null=True)
    td_description= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "training_data"

class TrainingDatadueFromHireDate(models.Model):
    training_data = models.ForeignKey(TrainingData,related_name="due_from_hire_date",on_delete=models.CASCADE)
    unit= models.CharField(max_length=250,default=None,blank=True,null=True)
    amount= models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "training_data_due_from_hire_date"




class Observations(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    o_id =models.IntegerField()
    observation_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_priority = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_closed_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_date_notified = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_deleted_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_description = models.TextField(default=None,blank=True,null=True)
    observation_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    observation_specification_section = models.TextField(default=None,blank=True,null=True)
    observation_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    # observation_assignee = models.CharField(max_length=250,default=None,blank=True,null=True)
    # observation_location = models.CharField(max_length=250,default=None,blank=True,null=True)
    # observation_trade = models.CharField(max_length=250,default=None,blank=True,null=True)
    # observation_created_by = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observations"

class ObservationType(models.Model):
    observation  = models.ForeignKey(Observations,related_name="type",on_delete=models.CASCADE)
    ot_id =models.IntegerField()
    ot_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ot_category = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_type"


class ObservationAssignee(models.Model):
    observation = models.ForeignKey(Observations,related_name="assignee", on_delete=models.CASCADE)
    oa_id = models.IntegerField()
    oa_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_assignee"

class ObservationAssigneeVendor(models.Model):
    observation_assignee = models.ForeignKey(ObservationAssignee, related_name="vendor", on_delete=models.CASCADE)
    oav_id = models.IntegerField()
    oa_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_assignee_vendor"
#
#
class ObservationLocation(models.Model):
    observation= models.ForeignKey(Observations,related_name="location", on_delete=models.CASCADE)
    ol_id = models.IntegerField()
    ol_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    ol_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    ol_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_location"

class ObservationTrade(models.Model):
    observation = models.ForeignKey(Observations,related_name="trade", on_delete=models.CASCADE)
    ot_id = models.IntegerField()
    ot_name  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ot_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_trade"


class ObservationCreatedBy(models.Model):
    observation = models.ForeignKey(Observations, related_name="created_by", on_delete=models.CASCADE)
    ocb_id = models.IntegerField()
    ocb_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    class Meta:
        db_table = "observation_created_by"


class PotientialChangeOrder(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pco_id = models.IntegerField()
    pco_status = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_grand_total = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_contract_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_created_by_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_request_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_executed = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_revision = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_schedule_impact_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_reason = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_request_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_package_title = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_potential_change_order_acronym_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_request_acronym_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_package_acronym_number = models.CharField(max_length=250,default=None,blank=True,null=True)
    pco_change_order_tiers = models.CharField(max_length=250,default=None,blank=True,null=True)

    # "id": 10806016,
    # "contract_id": 7471108,
    # "created_at": "2021-11-23T21:00:05Z",
    # "created_by_id": 4727005,
    # "number": "001",
    # "status": "approved",
    # "title": "",
    # "updated_at": "2021-11-30T16:24:09Z",
    # "change_order_request_id": 10589849,
    # "executed": false,
    # "grand_total": "-10000.0",
    # "revision": 0,
    # "schedule_impact_amount": 0,
    # "change_reason": "Buyout",
    # "change_order_request_title": "",
    # "change_order_package_title": "Demolition Buyout",
    # "potential_change_order_acronym_number": "",
    # "change_order_request_acronym_number": "",
    # "change_order_package_acronym_number": "CCO 001",
    # "change_order_tiers": 1
    class Meta:
        db_table = "potential_change_order"
#
#
#
class PrimeContract(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pc_id = models.IntegerField()
    prime_contract_grand_total = models.FloatField(default=None,blank=True,null=True)
    prime_contract_approved_change_order = models.FloatField(default=None,blank=True,null=True)
    prime_contract_revised_contract_amount = models.FloatField(default=None,blank=True,null=True)
    no_of_prime_contract_executed = models.IntegerField(default=None,blank=True,null=True)

    class Meta:
        db_table = "prime_contract"



class ProcoreSchedule(models.Model):
    project_id = models.CharField(max_length=50,default=None,blank=True,null=True)
    budget_percentage = models.CharField(max_length=20,default=None,blank=True,null=True)
    construction_percentage = models.CharField(max_length=20,default=None,blank=True,null=True)
    date = models.DateField(default=date.today)
    class Meta:
        db_table = "procore_schedule"

class PowerbiExportPdf(models.Model):
    id = models.BigAutoField(primary_key=True)
    user_name = models.TextField(default=None,blank=True,null=True)
    email = models.TextField(default=None,blank=True,null=True)
    status = models.IntegerField()
    url = models.TextField(default=None,blank=True,null=True)
    class Meta:
        db_table = 'powerbi_export_pdf'





# class ProcoreToken (models.Model):
#     id = models.BigAutoField(primary_key=True)
#     access_token = models.TextField(default=None,blank=True,null=True)
#     refresh_token = models.TextField(default=None,blank=True,null=True)
#     class Meta:
#         db_table = 'procore_token'
#
# class FailedJobs(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     connection = models.TextField(default=None,blank=True,null=True)
#     queue = models.TextField(default=None,blank=True,null=True)
#     payload = models.TextField(default=None,blank=True,null=True)
#     exception = models.TextField(default=None,blank=True,null=True)
#     failed_at = models.DateTimeField()
#     class Meta:
#         managed = False
#         db_table = 'failed_jobs'
#
#
# class Jobs(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     queue = models.CharField(max_length=191)
#     payload = models.TextField(default=None,blank=True,null=True)
#     attempts = models.PositiveIntegerField()
#     reserved_at = models.PositiveIntegerField(blank=True, null=True)
#     available_at = models.PositiveIntegerField()
#     created_at = models.PositiveIntegerField()
#
#     class Meta:
#         managed = False
#         db_table = 'jobs'
#
#
# class Migrations(models.Model):
#     migration = models.CharField(max_length=191)
#     batch = models.IntegerField()
#
#     class Meta:
#         managed = False
#         db_table = 'migrations'
#
#
# class Modules(models.Model):
#     module_name = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'modules'
#
#
# class OauthAccessTokens(models.Model):
#     id = models.CharField(primary_key=True, max_length=100,default=None,blank=True,null=True)
#     user_id = models.BigIntegerField(blank=True, null=True)
#     client_id = models.PositiveIntegerField()
#     name = models.CharField(max_length=191, blank=True, null=True)
#     scopes = models.TextField(blank=True, null=True)
#     revoked = models.IntegerField()
#     created_at = models.DateTimeField(blank=True, null=True)
#     updated_at = models.DateTimeField(blank=True, null=True)
#     expires_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'oauth_access_tokens'
#
#
# class OauthAuthCodes(models.Model):
#     id = models.CharField(primary_key=True, max_length=100,default=None,blank=True,null=True)
#     user_id = models.BigIntegerField()
#     client_id = models.PositiveIntegerField()
#     scopes = models.TextField(blank=True, null=True)
#     revoked = models.IntegerField()
#     expires_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'oauth_auth_codes'
#
#
# class OauthClients(models.Model):
#     user_id = models.BigIntegerField(blank=True, null=True)
#     name = models.CharField(max_length=191)
#     secret = models.CharField(max_length=100, blank=True, null=True)
#     redirect = models.TextField(default=None,blank=True,null=True)
#     personal_access_client = models.IntegerField()
#     password_client = models.IntegerField()
#     revoked = models.IntegerField()
#     created_at = models.DateTimeField(blank=True, null=True)
#     updated_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'oauth_clients'
#
#
# class OauthPersonalAccessClients(models.Model):
#     client_id = models.PositiveIntegerField()
#     created_at = models.DateTimeField(blank=True, null=True)
#     updated_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'oauth_personal_access_clients'
#
#
# class OauthRefreshTokens(models.Model):
#     id = models.CharField(primary_key=True, max_length=100,default=None,blank=True,null=True)
#     access_token_id = models.CharField(max_length=100,default=None,blank=True,null=True)
#     revoked = models.IntegerField()
#     expires_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'oauth_refresh_tokens'
#
#
# class PasswordResets(models.Model):
#     email = models.CharField(max_length=191)
#     token = models.CharField(max_length=191)
#     created_at = models.DateTimeField(blank=True, null=True)
#
#     class Meta:
#         managed = False
#         db_table = 'password_resets'
#
#
# class PermissionRoles(models.Model):
#     permission_id = models.IntegerField()
#     role_id = models.IntegerField()
#     task_id = models.IntegerField()
#     project_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'permission_roles'
#
#
# class Permissions(models.Model):
#     name = models.CharField(max_length=255)
#     display_name = models.CharField(max_length=255)
#     task_id = models.IntegerField()
#     module_id = models.IntegerField()
#     permission_type_status = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'permissions'
#
#
# class ProcoreAccessToken(models.Model):
#     access_token = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'procore_access_token'
#
#
# class SuperAdmins(models.Model):
#     name = models.CharField(max_length=255)
#     email = models.CharField(max_length=255)
#     password = models.CharField(max_length=255)
#     country_code = models.CharField(max_length=50,default=None,blank=True,null=True)
#     mobile_no = models.BigIntegerField()
#     title = models.CharField(max_length=255)
#     company_name = models.CharField(max_length=255)
#     address = models.TextField(default=None,blank=True,null=True)
#     profile_pic = models.CharField(max_length=255, blank=True, null=True)
#     remember_token = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'super_admins'
#
#
#
#
# class SyncTimeLogs(models.Model):
#     project_id = models.IntegerField()
#     sync_start_time = models.DateTimeField()
#     sync_end_time = models.DateTimeField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'sync_time_logs'
#
#
# class TblApproveSubmittals(models.Model):
#     procore_submittal_id = models.IntegerField()
#     spec_section = models.CharField(max_length=255, blank=True, null=True)
#     number = models.CharField(max_length=255, blank=True, null=True)
#     sort_number = models.CharField(max_length=255, blank=True, null=True)
#     n_revision = models.CharField(max_length=200,default=None,blank=True,null=True)
#     title = models.CharField(max_length=255, blank=True, null=True)
#     type = models.CharField(max_length=255, blank=True, null=True)
#     status = models.CharField(max_length=200,default=None,blank=True,null=True)
#     responsible_contractor = models.CharField(max_length=200, blank=True, null=True)
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     status_name = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_approve_submittals'
#
#
# class TblCloseoutItemType(models.Model):
#     type_name = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_closeout_item_type'
#
#
# class TblCloseoutItems(models.Model):
#     item_name = models.CharField(max_length=255, blank=True, null=True)
#     division_no = models.CharField(max_length=11, blank=True, null=True)
#     spec_sec_no = models.CharField(max_length=255)
#     spec_sec_description = models.CharField(max_length=255)
#     submittal_no = models.CharField(max_length=255)
#     description = models.TextField(default=None,blank=True,null=True)
#     status = models.CharField(max_length=100,default=None,blank=True,null=True)
#     type = models.CharField(max_length=255)
#     created_by = models.IntegerField(blank=True, null=True)
#     responsible_contractor_name = models.CharField(max_length=255)
#     responsible_contractor_id = models.IntegerField()
#     contact_person_email = models.CharField(max_length=255)
#     person_name = models.CharField(max_length=255, blank=True, null=True)
#     user_id = models.IntegerField()
#     comment = models.TextField(blank=True, null=True)
#     remark = models.TextField(default=None,blank=True,null=True)
#     due_date = models.DateField()
#     isdeleted = models.IntegerField(db_column='isDeleted')  # Field name made lowercase.
#     project_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_closeout_items'
#
#
# class TblCloseoutItemUploads(models.Model):
#     file = models.CharField(max_length=255)
#     file_name = models.CharField(max_length=255, blank=True, null=True)
#     file_type = models.CharField(max_length=255)
#     closeout_item_id = models.ForeignKey(
#         "TblCloseoutItems", to_field="id", db_constraint=False,
#         db_column='closeout_item_id', on_delete=models.DO_NOTHING
#     )
#     comment = models.TextField(blank=True, null=True)
#     remark = models.CharField(max_length=255, blank=True, null=True)
#     date = models.DateField(blank=True, null=True)
#     user_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_closeout_item_uploads'
#
#
# class TblCloseoutManual(models.Model):
#     manual_link = models.CharField(max_length=255)
#     version = models.CharField(max_length=255, blank=True, null=True)
#     date = models.DateTimeField(blank=True, null=True, )
#     created_by = models.IntegerField(blank=True, null=True)
#     status = models.IntegerField(blank=True, null=True)
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField(auto_now_add=True)
#     updated_at = models.DateTimeField(auto_now_add=True)
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_closeout_manual'
#
#
# class TblCompanies(models.Model):
#     procore_company_id = models.IntegerField()
#     company_name = models.CharField(max_length=255)
#     owner_name = models.CharField(max_length=255, blank=True, null=True)
#     email = models.CharField(max_length=255, blank=True, null=True)
#     country_code = models.IntegerField(blank=True, null=True)
#     mobile_no = models.BigIntegerField(blank=True, null=True)
#     country = models.CharField(max_length=255, blank=True, null=True)
#     state = models.CharField(max_length=255, blank=True, null=True)
#     city = models.CharField(max_length=255, blank=True, null=True)
#     address = models.TextField(blank=True, null=True)
#     pincode = models.IntegerField(blank=True, null=True)
#     logo = models.CharField(max_length=255, blank=True, null=True)
#     isactive = models.IntegerField(db_column='isActive')  # Field name made lowercase.
#     is_registered = models.IntegerField()
#     project_limit = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_companies'
#
#
# class TblCompanyUsers(models.Model):
#     user_id = models.ForeignKey(
#         "Users", to_field="id", db_constraint=False,
#         db_column='user_id', on_delete=models.DO_NOTHING
#     )
#     company_id = models.IntegerField()
#     role_id = models.IntegerField()
#     isactive = models.IntegerField(db_column='isActive', blank=True, null=True)  # Field name made lowercase.
#     isprocoreuser = models.IntegerField(db_column='isProcoreUser')  # Field name made lowercase.
#     ispasswordchange = models.IntegerField(db_column='isPasswordChange')  # Field name made lowercase.
#     issuperadmin = models.IntegerField(db_column='isSuperAdmin')  # Field name made lowercase.
#     isdeleted = models.IntegerField(db_column='isDeleted')  # Field name made lowercase.
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_company_users'
#
#
# class TblCoverPages(models.Model):
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     pdf_path = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     modified_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_cover_pages'
#
#
# class TblCustomRoles(models.Model):
#     role_id = models.IntegerField()
#     company_id = models.IntegerField()
#     project_id = models.IntegerField()
#     created_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_custom_roles'
#
#
# class TblDrawingSets(models.Model):
#     project_id = models.IntegerField()
#     procore_set_id = models.IntegerField()
#     set_name = models.CharField(max_length=255)
#     set_date = models.DateField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_drawing_sets'
#
#
# class TblDrawings(models.Model):
#     procore_drawing_id = models.IntegerField()
#     project_id = models.IntegerField()
#     number = models.CharField(max_length=255)
#     discipline = models.CharField(max_length=255)
#     title = models.CharField(max_length=255)
#     date = models.DateField(blank=True, null=True)
#     revision = models.IntegerField()
#     drawing_set_id = models.IntegerField()
#     trade_id = models.IntegerField()
#     attachment = models.CharField(max_length=255)
#     closeout_attachment = models.CharField(max_length=2000, blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     png_attachment = models.CharField(max_length=255, blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_drawings'
#
#
# class TblIndexPages(models.Model):
#     project_id = models.IntegerField()
#     pdf_path = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_index_pages'
#
#
# class TblMasterSectionList(models.Model):
#     section_name = models.CharField(max_length=255)
#     folder_name = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_master_section_list'
#
#
# class TblProgressphotos(models.Model):
#     procore_photo_id = models.IntegerField()
#     photo_url = models.CharField(max_length=255, blank=True, null=True)
#     thumbnail_url = models.CharField(max_length=255, blank=True, null=True)
#     type = models.CharField(max_length=5)
#     photo_date = models.DateField(blank=True, null=True)
#     project_id = models.IntegerField(blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_progressphotos'
#
#
# class TblProjectContacts(models.Model):
#     project_id = models.IntegerField()
#     name = models.CharField(max_length=255)
#     email = models.CharField(max_length=255)
#     title = models.CharField(max_length=255, blank=True, null=True)
#     country_code = models.CharField(max_length=50, blank=True, null=True)
#     company_name = models.CharField(max_length=255)
#     mobile_no = models.CharField(max_length=255, blank=True, null=True)
#     address = models.TextField(blank=True, null=True)
#     profile_pic = models.CharField(max_length=255, blank=True, null=True)
#     procore_id = models.IntegerField(blank=True, null=True)
#     is_visible = models.IntegerField()
#     status = models.IntegerField()
#     role_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_project_contacts'
#
#
# class TblProjectIndex(models.Model):
#     project_id = models.IntegerField()
#     section_id = models.ForeignKey(
#         "TblMasterSectionList", to_field="id", db_constraint=False,
#         db_column='section_id', on_delete=models.DO_NOTHING
#     )
#     title = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_project_index'
#
#
# class TblProjects(models.Model):
#     procore_project_id = models.IntegerField()
#     project_name = models.CharField(max_length=255)
#     project_number = models.CharField(max_length=255, blank=True, null=True)
#     owner_name = models.CharField(max_length=255, blank=True, null=True)
#     address = models.TextField(default=None,blank=True,null=True)
#     city = models.CharField(max_length=200, blank=True, null=True)
#     state = models.CharField(max_length=200, blank=True, null=True)
#     country = models.CharField(max_length=200, blank=True, null=True)
#     zip = models.IntegerField(blank=True, null=True)
#     ebinder_name = models.CharField(max_length=255, blank=True, null=True)
#     image = models.CharField(max_length=255, blank=True, null=True)
#     company_name = models.CharField(max_length=255, blank=True, null=True)
#     project_logo = models.CharField(max_length=255, blank=True, null=True)
#     isactive = models.IntegerField(db_column='isActive')  # Field name made lowercase.
#     status = models.IntegerField(blank=True, null=True)
#     completion_date = models.DateTimeField(blank=True, null=True)
#     project_status = models.IntegerField()
#     reimport_status = models.IntegerField(blank=True, null=True)
#     isdeleted = models.IntegerField(db_column='isDeleted')  # Field name made lowercase.
#     company = models.ForeignKey(TblCompanies, on_delete=models.CASCADE)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_projects'
#
#     def __str__(self):
#         return self.project_name
#
#
# class TblProjectAssigns(models.Model):
#     project_id = models.ForeignKey("TblProjects", to_field="id", db_constraint=False,
#                                    db_column='project_id', on_delete=models.DO_NOTHING)
#     user_id = models.IntegerField()
#     isdeleted = models.IntegerField(db_column='isDeleted')  # Field name made lowercase.
#     role_id = models.IntegerField()
#     isinvited = models.IntegerField(db_column='isInvited')  # Field name made lowercase.
#     is_visible = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_project_assigns'
#
#
# class TblResponseFilters(models.Model):
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     procore_response_id = models.IntegerField()
#     response_value = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_response_filters'
#
#
# class TblRfiQuestions(models.Model):
#     procore_question_id = models.IntegerField()
#     question_body = models.TextField(default=None,blank=True,null=True)
#     rfi_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     question_date = models.DateTimeField()
#     created_by = models.CharField(max_length=255)
#     project_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_rfi_questions'
#
#
# class TblRfiQuestionsAttachments(models.Model):
#     procore_attachment_id = models.BigIntegerField()
#     question_id = models.IntegerField()
#     file_name = models.CharField(max_length=255)
#     name = models.CharField(max_length=255)
#     url = models.CharField(max_length=255)
#     rfi_id = models.IntegerField(blank=True, null=True)
#     closeout_attachment_url = models.CharField(max_length=2000, blank=True, null=True)
#     closeout_rfi_attachments_url = models.CharField(max_length=255, blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_rfi_questions_attachments'
#
#
# class TblRfis(models.Model):
#     procore_rfi_id = models.IntegerField()
#     subject = models.CharField(max_length=255)
#     number = models.CharField(max_length=255, blank=True, null=True)
#     status = models.CharField(max_length=100,default=None,blank=True,null=True)
#     question_body = models.TextField(default=None,blank=True,null=True)
#     responsible_contractor = models.CharField(max_length=255, blank=True, null=True)
#     assignees = models.CharField(max_length=255, blank=True, null=True)
#     close_date = models.DateTimeField()
#     due_date = models.CharField(max_length=255, blank=True, null=True)
#     location = models.CharField(max_length=255, blank=True, null=True)
#     received_from = models.CharField(max_length=255, blank=True, null=True)
#     cost_code = models.CharField(max_length=255, blank=True, null=True)
#     schedule_impact = models.CharField(max_length=255, blank=True, null=True)
#     reference = models.CharField(max_length=255, blank=True, null=True)
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     date_initiated = models.DateTimeField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_rfis'
#
#
# class TblRfiAnswers(models.Model):
#     procore_answer_id = models.IntegerField()
#     rfi_id = models.IntegerField()
#     answer = models.TextField(default=None,blank=True,null=True)
#     answer_date = models.DateTimeField()
#     official = models.CharField(max_length=233)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_by = models.CharField(max_length=255)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_rfi_answers'
#
#
# class TblRfiAttachments(models.Model):
#     procore_attachment_id = models.BigIntegerField()
#     answer_id = models.ForeignKey(
#         "TblRfiAnswers", to_field="id", db_constraint=False,
#         db_column='answer_id', on_delete=models.DO_NOTHING)
#     file_name = models.CharField(max_length=255)
#     name = models.CharField(max_length=255)
#     url = models.CharField(max_length=255)
#     rfi_id = models.IntegerField(blank=True, null=True)
#     closeout_attachment_url = models.CharField(max_length=2000, blank=True, null=True)
#     closeout_rfi_attachments_url = models.CharField(max_length=255, blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_rfi_attachments'
#
#
# class TblRoles(models.Model):
#     role_name = models.CharField(max_length=200,default=None,blank=True,null=True)
#     custom_role = models.IntegerField()
#     is_company_role = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_roles'
#
#
# class TblSpecSectionDivisions(models.Model):
#     procore_division_id = models.IntegerField()
#     project_id = models.IntegerField()
#     description = models.CharField(max_length=255)
#     number = models.CharField(max_length=100,default=None,blank=True,null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_spec_section_divisions'
#
#
# class TblSpecSections(models.Model):
#     procore_spec_sec_id = models.IntegerField()
#     project_id = models.IntegerField()
#     number = models.CharField(max_length=255)
#     sort_number = models.CharField(max_length=11)
#     description = models.CharField(max_length=255)
#     revision = models.CharField(max_length=255)
#     issued_date = models.CharField(max_length=255, blank=True, null=True)
#     attachment = models.CharField(max_length=2000, blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_spec_sections'
#
#
# class TblSpecifications(models.Model):
#     procore_spec_id = models.IntegerField()
#     project_id = models.IntegerField()
#     number = models.CharField(max_length=100,default=None,blank=True,null=True)
#     sort_number = models.CharField(max_length=100,default=None,blank=True,null=True)
#     description = models.CharField(max_length=255)
#     label = models.CharField(max_length=255)
#     revision = models.IntegerField(blank=True, null=True)
#     issued_date = models.DateTimeField(blank=True, null=True)
#     spec_set = models.CharField(max_length=255, blank=True, null=True)
#     spec_cat_id = models.IntegerField(blank=True, null=True)
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     current_revision_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_specifications'
#
#
# class TblSubmittalAttachments(models.Model):
#     submittal_id = models.IntegerField()
#     submittal_attachment_id = models.BigIntegerField()
#     attachment_name = models.CharField(max_length=255)
#     attachment_url = models.CharField(max_length=255)
#     closeout_attachment_url = models.CharField(max_length=2000, blank=True, null=True)
#     filename = models.CharField(max_length=255)
#     project_id = models.IntegerField()
#     closeout_company_id = models.IntegerField(blank=True, null=True)
#     submittal_workflow_id = models.IntegerField()
#     procore_workflow_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_submittal_attachments'
#
#
# class TblSubmittalStatusId(models.Model):
#     submittal_id = models.IntegerField()
#     submittal_status = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_submittal_status_id'
#
#
# class TblSubmittalWorkflow(models.Model):
#     procore_workflow_id = models.IntegerField()
#     procore_submittal_id = models.IntegerField()
#     submittal_id = models.IntegerField()
#     response_id = models.IntegerField()
#     response = models.CharField(max_length=255)
#     submittal_attachment_id = models.IntegerField()
#     project_id = models.IntegerField()
#     returned_date = models.DateField(blank=True, null=True)
#     sent_date = models.DateField(blank=True, null=True)
#     due_date = models.DateField(blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_submittal_workflow'
#
#
# class TblTrades(models.Model):
#     procore_drawing_discipline_id = models.IntegerField()
#     position = models.IntegerField()
#     name = models.CharField(max_length=255)
#     project_id = models.IntegerField()
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'tbl_trades'
#
#
# class Users(models.Model):
#     name = models.CharField(max_length=255)
#     email = models.CharField(max_length=255)
#     password = models.CharField(max_length=255)
#     country_code = models.CharField(max_length=255, blank=True, null=True)
#     designation = models.CharField(max_length=255, blank=True, null=True)
#     mobile_no = models.CharField(max_length=255, blank=True, null=True)
#     company_name = models.CharField(max_length=255, blank=True, null=True)
#     address = models.TextField(blank=True, null=True)
#     profile_pic = models.CharField(max_length=255, blank=True, null=True)
#     procore_id = models.IntegerField()
#     api_version = models.IntegerField()
#     platform = models.CharField(max_length=255, blank=True, null=True)
#     access_token = models.TextField(blank=True, null=True)
#     remember_token = models.CharField(max_length=100, blank=True, null=True)
#     created_at = models.DateTimeField()
#     updated_at = models.DateTimeField()
#
#     class Meta:
#         managed = False
#         db_table = 'users'
#
#     def __str__(self):
#         return self.name
#



class ProcoreMeeting(models.Model):
    group_title = models.CharField(max_length= 250,default=None,blank=True,null=True)
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    meeting_id = models.TextField()
    description =  models.TextField(max_length=250,default=None,blank=True,null=True)
    ends_at =  models.TextField(max_length=250,default=None,blank=True,null=True)
    mode =  models.TextField(max_length=250,default=None,blank=True,null=True)
    parent_id =  models.TextField(max_length=250,default=None,blank=True,null=True)
    position =  models.TextField(max_length=250,default=None,blank=True,null=True)
    starts_at =  models.TextField(max_length=250,default=None,blank=True,null=True)
    title =  models.TextField(max_length=250,default=None,blank=True,null=True)



# class Meeting(models.Model):
#     # meeting_id = models.IntegerField()
#     procore_meeting = models.ForeignKey(ProcoreMeeting, related_name='meetings', on_delete=models.CASCADE)
#     # description =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # ends_at =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # mode =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # parent_id =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # position =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # starts_at =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     # title =  models.TextField(max_length=250,default=None,blank=True,null=True)
#     class Meta:
#         db_table = "meeting"


class Images(models.Model):
    image_id = models.IntegerField()
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    image_url = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_description = models.TextField(default=None,blank=True,null=True)
    image_taken_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_updated_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_location = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_uploader_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_uploader_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    image_uploader_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    
class BusyBusy(models.Model):
    busybusy_app_id = models.TextField(default=None,blank=True,null=True)
    busybusy_created_by= models.TextField(default=None,blank=True,null=True)
    busybusy_last_edited_by= models.TextField(default=None,blank=True,null=True)
    busybusy_employee_id= models.TextField(default=None,blank=True,null=True)
    busybusy_first_name= models.TextField(default=None,blank=True,null=True)
    busybusy_last_name= models.TextField(default=None,blank=True,null=True)
    busybusy_employee_positions= models.TextField(default=None,blank=True,null=True)
    busybusy_employee= models.TextField(default=None,blank=True,null=True)
    busybusy_date= models.TextField(default=None,blank=True,null=True)
    busybusy_start= models.TextField(default=None,blank=True,null=True)
    busybusy_end= models.TextField(default=None,blank=True,null=True)
    busybusy_wage= models.TextField(default=None,blank=True,null=True)
    busybusy_hours= models.TextField(default=None,blank=True,null=True)
    busybusy_breakout_hours= models.TextField(default=None,blank=True,null=True)
    busybusy_wage_type= models.TextField(default=None,blank=True,null=True)
    busybusy_cost= models.TextField(default=None,blank=True,null=True)
    busybusy_safety_sign_off_injured= models.TextField(default=None,blank=True,null=True)
    busybusy_correct_time_sign_off_time_accurate= models.TextField(default=None,blank=True,null=True)
    busybusy_budgeted_hours= models.TextField(default=None,blank=True,null=True)
    busybusy_budgeted_cost= models.TextField(default=None,blank=True,null=True)
    busybusy_customer= models.TextField(default=None,blank=True,null=True)
    busybusy_project_city= models.TextField(default=None,blank=True,null=True)
    busybusy_project_state= models.TextField(default=None,blank=True,null=True)
    busybusy_project_group= models.TextField(default=None,blank=True,null=True)
    busybusy_project_number= models.TextField(default=None,blank=True,null=True)
    busybusy_project= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project1_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project1= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project2_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project2= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project3_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project3= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project4_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project4= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project5_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project5= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project6_number= models.TextField(default=None,blank=True,null=True)
    busybusy_sub_project6= models.TextField(default=None,blank=True,null=True)
    busybusy_cost_code= models.TextField(default=None,blank=True,null=True)
    busybusy_cost_code_description= models.TextField(default=None,blank=True,null=True)
    busybusy_cost_code_group= models.TextField(default=None,blank=True,null=True)
    busybusy_equipment= models.TextField(default=None,blank=True,null=True)
    busybusy_equipment_make_model= models.TextField(default=None,blank=True,null=True)
    busybusy_equipment_meter_reading= models.TextField(default=None,blank=True,null=True)
    busybusy_description= models.TextField(default=None,blank=True,null=True)

class AccessToken(models.Model):
    token = models.TextField()
    count = models.IntegerField()
    created_at = models.DateTimeField(auto_now=True)
    updated_at = models.DateTimeField(auto_now=True)

class GetTickets(models.Model):
    actualFinishDate =  models.CharField(max_length=250,default=None,blank=True,null=True)
    actualStartDate =  models.CharField(max_length=250,default=None,blank=True,null=True)
    crewSize =  models.CharField(max_length=250,default=None,blank=True,null=True)
    description =  models.TextField(default=None,blank=True,null=True)
    get_ticket_id =  models.CharField(max_length=250,default=None,blank=True,null=True)
    locationId =  models.CharField(max_length=250,default=None,blank=True,null=True)
    plannedFinishDate =  models.CharField(max_length=250,default=None,blank=True,null=True)
    plannedStartDate =  models.CharField(max_length=250,default=None,blank=True,null=True)
    roleId =  models.CharField(max_length=250,default=None,blank=True,null=True)
    get_ticket_type =  models.CharField(max_length=250,default=None,blank=True,null=True)
    yPosition =  models.CharField(max_length=250,default=None,blank=True,null=True)
    
    
class TblProjectsForms(models.Model):
    project_id = models.IntegerField()
    project_name = models.CharField(max_length=255)

    class Meta:
        managed = False
        db_table = 'tbl_projects_forms'



class TblFormData(models.Model):
    question = models.CharField(max_length=255)
    answer = models.CharField(max_length=255)
    form = models.ForeignKey('TblForms', models.DO_NOTHING)
    percent = models.IntegerField()
    class Meta:
        managed = False
        db_table = 'tbl_form_data'


class TblForms(models.Model):
    project = models.ForeignKey('TblProjectsForms', models.DO_NOTHING)
    name = models.CharField(max_length=255)
    updated_at = models.DateTimeField()
    created_by = models.CharField(max_length=255)
    created_at = models.DateTimeField()

    class Meta:
        managed = False
        db_table = 'tbl_forms'



class ProjectRoles(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pr_id = models.IntegerField(default=None)
    pr_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    pr_role = models.CharField(max_length=250,default=None,blank=True,null=True)
    pr_contact_id = models.IntegerField()
    pr_user_id = models.IntegerField()
    pr_is_active = models.CharField(max_length=250,default=None,blank=True,null=True)
    pr_created_at = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "project_roles"
        
        




class PunchItems(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pi_id = models.IntegerField()
    pi_altitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_closed_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_cost_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_cost_impact = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_cost_impact_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_created_at = models.DateTimeField(auto_now=True)
    pi_deleted_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_description = models.TextField(default=None,blank=True,null=True)
    pi_due_date = models.TextField(default=None,blank=True,null=True)
    pi_has_resolved_responses = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_has_unresolved_responses = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_horizontal_accuracy = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_latitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_longitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_manager_notified_at = models.DateTimeField(auto_now=True)
    pi_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_overdue = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_position = models.IntegerField(default=None)
    pi_priority = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_private = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_reference = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_schedule_impact = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_schedule_impact_days = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_status =models.TextField(default=None,blank=True,null=True)
    pi_updated_at = models.TextField(default=None,blank=True,null=True)
    pi_vertical_accuracy = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_workflow_status = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items"

class PunchItemsAssignees(models.Model):
    punch_item = models.ForeignKey(PunchItems,related_name='assignees',on_delete=models.CASCADE)
    pia_id = models.IntegerField()
    pia_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    pia_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_assignees"

class PunchItemsAssignments(models.Model):
    punch_item = models.ForeignKey(PunchItems,related_name='assignments',on_delete=models.CASCADE)
    piam_id = models.IntegerField()
    # piam_approved = models.CharField(max_length=250,default=None,blank=True,null=True)
    # piam_login_information_id = models.CharField(max_length=250, default=None, blank=True, null=True)
    # piam_login_information_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_manager_accepted_at= models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_notified_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_responded_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_status = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_vendor_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_user_name = models.CharField(max_length=250, default=None, blank=True, null=True)


    class Meta:
        db_table = "punch_items_assignments"


class PunchItemsBallInCourt(models.Model):
    punch_item = models.ForeignKey(PunchItems,related_name='ball_in_court',on_delete=models.CASCADE)
    pibic_id = models.IntegerField()
    pibic_locale = models.CharField(max_length=250,default=None,blank=True,null=True)
    pibic_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    pibic_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_ball_in_court"

class PunchItemsClosedBy(models.Model):
    punch_item = models.ForeignKey(PunchItems,related_name='closed_by',on_delete=models.CASCADE)
    picb_id = models.IntegerField()
    picb_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    picb_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_closed_by"

class PunchItemsCreatedBy(models.Model):
    punch_item = models.ForeignKey(PunchItems, related_name='created_by', on_delete=models.CASCADE)
    pic_id = models.IntegerField()
    pic_login = models.CharField(max_length=250,default=None,blank=True,null=True)
    pic_name =  models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_created_by"


class PunchItemsType(models.Model):
    punch_item = models.ForeignKey(PunchItems, related_name='punch_item_type', on_delete=models.CASCADE)
    pit_id = models.IntegerField()
    pit_name = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_type"

class PunchItemsTrade(models.Model):
    punch_item = models.ForeignKey(PunchItems, related_name='trade', on_delete=models.CASCADE)
    pitr_id = models.IntegerField()
    pitr_active = models.CharField(max_length=250,default=None,blank=True,null=True)
    pitr_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    pitr_updated_at = models.TextField(default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items_trade"
        
        
class TblFormAvg(models.Model):
    form = models.ForeignKey('TblForms', models.DO_NOTHING)
    safety = models.FloatField()
    shedule = models.FloatField()
    document_control = models.FloatField()
    financial = models.FloatField()
    quality = models.FloatField()
    overall = models.FloatField()



    class Meta:
        managed = False
        db_table = 'tbl_form_avg'



class CommitmentChangeOrder(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    commitment_id = models.IntegerField()
    commitment_contract_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_created_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_created_by_id = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_deleted_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_due_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_executed = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_invoiced_date = models.CharField(max_length=250,default=None,blank=True,null=True)
    commitment_grand_total = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_number = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_reviewed_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_signed_change_order_received_date = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_status = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_title = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_revision = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_designated_reviewer_login = models.CharField(max_length=250, default=None, blank=True, null=True)
    commitment_designated_reviewer_name = models.CharField(max_length=250, default=None, blank=True, null=True)

    class Meta:
        db_table = "commitment_change_order"
        
        
        
        
class DailyTime(models.Model):
    date =models.CharField(max_length=250,default=None,blank=True,null=True)
    start_time = models.CharField(max_length=250,default=None,blank=True,null=True)
    end_time = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "daily_time"

        
class PunchItems1(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    pi_id = models.IntegerField()
    pi_altitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_assignees = models.JSONField(max_length=1000,default=None,blank=True,null=True)
    pi_ball_in_court = models.JSONField(max_length=1000,default=None,blank=True,null=True)
    pi_created_by = models.JSONField(max_length=1000,default=None,blank=True,null=True)
    pi_punch_item_type = models.JSONField(max_length=1000,default=None,blank=True,null=True)
    pi_trade = models.JSONField(max_length=1000,default=None,blank=True,null=True)
    pi_closed_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_closed_by = models.JSONField(max_length=1000, default=None, blank=True, null=True)
    pi_cost_code = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_cost_impact = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_cost_impact_amount = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_created_at = models.DateTimeField(auto_now=True)
    pi_deleted_at = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_description = models.TextField(default=None,blank=True,null=True)
    pi_due_date = models.TextField(default=None,blank=True,null=True)
    pi_has_resolved_responses = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_has_unresolved_responses = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_horizontal_accuracy = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_latitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_longitude = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_manager_notified_at = models.DateTimeField(auto_now=True)
    pi_name = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_overdue = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_position = models.IntegerField(default=None)
    pi_priority = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_private = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_reference = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_schedule_impact = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_schedule_impact_days = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_status =models.TextField(default=None,blank=True,null=True)
    pi_updated_at = models.TextField(default=None,blank=True,null=True)
    pi_vertical_accuracy = models.CharField(max_length=250,default=None,blank=True,null=True)
    pi_workflow_status = models.CharField(max_length=250,default=None,blank=True,null=True)

    class Meta:
        db_table = "punch_items1"

class PunchItemsAssignments1(models.Model):
    punch_item = models.ForeignKey(PunchItems1,related_name='assignments1',on_delete=models.CASCADE)
    piam_id = models.IntegerField()
    # piam_approved = models.CharField(max_length=250,default=None,blank=True,null=True)
    # piam_login_information_id = models.CharField(max_length=250, default=None, blank=True, null=True)
    # piam_login_information_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_manager_accepted_at= models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_notified_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_responded_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_status = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_updated_at = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_vendor_name = models.CharField(max_length=250, default=None, blank=True, null=True)
    piam_user_name = models.CharField(max_length=250, default=None, blank=True, null=True)


    class Meta:
        db_table = "punch_items_assignments1"
        
class UserDirectory(models.Model):
    project = models.ForeignKey(ProjectModel, on_delete=models.CASCADE)
    ud_id = models.IntegerField()
    ud_name  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_first_name  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_initials  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_last_name  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_business_id  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_address  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_avatar  = models.CharField(max_length=250,default=None,blank=True,null=True)
    ud_business_phone = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_business_phone_extension = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_city  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_contact_id  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_country_code  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_created_at  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_email_address  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_employee_id   = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_erp_integrated_accountant  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_fax_number  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_is_active = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_is_employee  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_job_title  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_last_login_at  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_mobile_phone  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_notes  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_origin_data  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_origin_id  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_state_code  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_updated_at  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_welcome_email_sent_at  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_zip  = models.CharField(max_length=250, default=None, blank=True, null=True)
    ud_email_signature = models.TextField(default=None, blank=True, null=True)
    ud_permission_template   = models.JSONField(max_length=1000, default=None, blank=True, null=True)
    ud_vendor  = models.JSONField(max_length=1000, default=None, blank=True, null=True)
    ud_company_permission_template  = models.JSONField(max_length=1000, default=None, blank=True, null=True)
    class Meta:
        db_table = "user_directory1"