from django.shortcuts import redirect
from django.urls import include, path,re_path
from rest_framework import permissions

from . import views, skilescron
# import debug_toolbar
from . import  cron
from django.conf import settings
from . import  views as project_controller
from django.contrib import admin
from django.urls import path, re_path, include
# drf_yasg code starts here
from rest_framework import permissions
from drf_yasg.views import get_schema_view
from drf_yasg import openapi

# from .views import  BusyBusyView
from .views import BusyBusyView

schema_view = get_schema_view(
    openapi.Info(
        title="PowerBi API",
        default_version='v1',
    ),
    public=True,
    permission_classes=(permissions.AllowAny,),
)
from rest_framework.routers import DefaultRouter

urlpatterns = [
    ####### PROCORE ###########

    re_path(r'^swagger(?P<format>\.json|\.yaml)$', schema_view.without_ui(cache_timeout=0), name='schema-json'),
    re_path(r'^swagger/$', schema_view.with_ui('swagger', cache_timeout=0), name='schema-swagger-ui'),
    re_path(r'^redoc/$', schema_view.with_ui('redoc', cache_timeout=0), name='schema-redoc'),
    path('procore_access_token', project_controller.procore_access_token, name='procore_access_token'),
    path('procore_login', project_controller.procore_login, name='procore_login'),
    path('refresh_token', project_controller.refresh_token, name='refresh_token'),
    # path('fetch_pdf', cron.createcron, name='fetch_pdf'),
    # re_path(r'^o/', include('oauth2_provider.urls', namespace='oauth2_provider_')),
    path('change_order_package_view', project_controller.change_order_package_view, name='change_order_package_view'),
    path('daily_huddles', project_controller.daily_huddles, name='daily_huddles'),
    path('schedule_task', project_controller.schedule_task, name='schedule_task'),
    # # path('busybusy', project_controller.busybusy, name='busybusy'),
    path('inspection', project_controller.inspection, name='inspection'),
    path('invoicing', project_controller.invoicing, name='invoicing'),
    path('percent_plan_complete', project_controller.percent_plan_complete, name='percent_plan_complete'),
    path('potential_change_order', project_controller.potential_change_order, name='potential_change_order'),
    path('prime_contract_general_view', project_controller.prime_contract_general_view, name='prime_contract_general_view'),
    path('prime_contract_change_order', project_controller.prime_contract_change_order, name='prime_contract_change_order'),
    path('prime_contract_schedule_value', project_controller.prime_contract_schedule_value, name='prime_contract_schedule_value'),
    path('work_task', project_controller.work_task, name='work_task'),
    path('submittals', project_controller.submittals, name='submittals'),
    path('rfi', project_controller.rfi, name='rfi'),
    path('daily_log_manpower', project_controller.daily_log_manpower, name='daily_log_manpower'),
    path('commitments', project_controller.commitments, name='commitments'),
    path('budget', project_controller.budget, name='budget'),
    path('weekly_wipedown', project_controller.weekly_wipedown, name='weekly_wipedown'),
    path('change_events', project_controller.change_events, name='change_events'),
    path('observation', project_controller.observation, name='observation'),
    path('project_user', project_controller.project_user, name='project_user'),
    path('project_details', project_controller.project_details, name='project_details'),
    path('procore_meetings', project_controller.procore_meetings, name='procore_meetings'),
    path('image', project_controller.image, name='image'),
    path('create_busybusy', project_controller.create_busybusy, name='create_busybusy'),
    path('busybusy', BusyBusyView.as_view()),
    # path('get_tickets', project_controller.GetTicketsView.as_view()),
    path('training_data', project_controller.training_data, name='training_data'),
    path('training_data_projectwise', project_controller.training_data_projectwise, name='training_data_projectwise'),
    path('formsdata' , views.formsdata , name='formsdata'),
    path('procore_refresh_token' , views.procore_refresh_token , name='procore_refresh_token'),
    path('projects_roles' , views.projects_roles , name='projects_roles'),
    path('punch_items' , views.punch_items , name='punch_items'),
    path('projects_update_models' , views.projects_update_models , name='projects_update_models'),
    path('all_projects_roles' , views.all_projects_roles , name='all_projects_roles'),
    path('commitment_change_order' , views.commitment_change_order , name='commitment_change_order'),
    path('daily_time',views.daily_time,name='daily_time'),
    path('work_task_new',views.work_task_new,name='work_task_new'),
    path('incident', views.incident, name='incident'),
    path('checkmail', project_controller.checkmail, name='checkmail'),

    ]
